#Requires -Modules 'ActiveDirectory'
Param(
    [Parameter(Mandatory)]
    [hashtable]$Parameter
)

# Only executed on primary or standalone Domain Controller
If (@('primary','standalone') -contains $Parameter['deployment.type']) {
    $GetContentSplat = @{
        Path = "$($PSScriptRoot)\$($MyInvocation.MyCommand)".Replace('.ps1', ".csv")
    }
    $CSVImport = (Get-Content @GetContentSplat) | ConvertFrom-Csv

    ForEach ($OU in $CSVImport) {
        $OUName, $OUPath = $OU.DistinguishedName -split ',', 2
        If ($OUPath.Length -ne 0) {
            $OUPath += ','
        }

        $NewADOrganizationalUnitSplat = @{
            Name                            = $OUName.Substring(3)
            Path                            = $OUPath + 'DC=' + $Parameter['addsconfig.domainname'].Replace('.', ',DC=')
            Description                     = $OU.Description
            ProtectedFromAccidentalDeletion = $False
            ErrorAction                     = 'SilentlyContinue'
        }
        New-ADOrganizationalUnit @NewADOrganizationalUnitSplat
    }
}